demo.state2 = function(){};

var barrel;
var base;
var bullets;
var velocity = 1500;
var nextfire = 0;
var firerate = 200;
var enemy; 
var bullet;
var enemyGroup;
demo.state2.prototype = {
    preload: function(){
        game.load.spritesheet('saber', 'assets/spritesheets/saberSheet.png', 302,302);
    },
    create: function(){
        game.stage.backgroundColor = '#DDDDDD';
        console.log('state2');
        
        base = game.add.sprite(centerX, centerY, 'saber');
        base.anchor.setTo(0.5);
        base.scale.setTo(0.5);
        base.tint = 0xaaaaaa;
        
        
        bullets = game.add.group();
        bullets.enableBody = true;
        bullets.physicsBodyType = Phaser.Physics.ARCADE;
        bullets.createMultiple(50, 'saber');
        bullets.setAll('checkWorldBounds', true);
        bullets.setAll('outOfBoundsKill', true)
        bullets.setAll('anchor.y', 0.5);
        bullets.setAll('scale.y', 0.3);
        
        barrel = game.add.sprite(centerX, centerY, 'saber');
        barrel.anchor.setTo(0.5, 0.1);
        barrel.scale.setTo(-0.5);
        
        enemy = game.add.sprite(100, 200, 'saber');
        game.physics.enable(enemy);
        
        enemyGroup = game.add.group();
        enemyGroup.enableBody = true;
        enemyGroup.physicsBodyType = Phaser.Physics.ARCADE;
        
        for(let i = 0; i<3; i++){
            enemyGroup.create(1300,350*i+100, 'saber');
        }
        
        enemyGroup.setAll('anchor.y', 0.5);
        enemyGroup.setAll('anchor.x', 0.5);
        enemyGroup.setAll('scale.y', 0.5);
        enemyGroup.setAll('scale.x', 0.5);
    },
    update: function(){
        barrel.rotation = game.physics.arcade.angleToPointer(barrel)-80;
        if(game.input.activePointer.isDown){
            this.fire();
        }
        
        game.physics.arcade.overlap(bullets, enemy, this.hitEnemy);
        game.physics.arcade.overlap(bullets, enemyGroup, this.hitGroup);
    },
    fire: function(){
        if(game.time.now > nextfire){
            nextfire = game.time.now + firerate;
            console.log('firing');
            bullet = bullets.getFirstDead();
            bullet.reset(barrel.x, barrel.y);
            
            bullet.tint = Math.random() * 0xffffff;
            game.physics.arcade.moveToPointer(bullet, velocity);
            bullet.rotation = game.physics.arcade.angleToPointer(bullet);
        }
    },
    hitEnemy: function(){
        console.log("hit");
        enemy.kill();
        bullet.kill();
    },
    
    hitGroup: function(b, e){
        console.log("hit");
        b.kill();
        e.kill();
    }
};